=== debian/control ===
Source: splinter
Section: python
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends: debhelper-compat (= 12), dh-python, python3-setuptools, python3-all, python3-sphinx, python3-sphinx-rtd-theme, python3-pytest, python3-selenium, python3-django, python3-flask
Standards-Version: 4.4.1
Homepage: https://github.com/cobrateam/splinter
Testsuite: autopkgtest-pkg-python

Package: python3-splinter
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Suggests: python-splinter-doc
Description: Python test framework for web applications (Python 3)
 This package contains an open source tool for testing web applications using
 Python. It lets you automate browser actions, such as visiting URLs and
 interacting with their items.
 .
 This package installs the library for Python 3.

Package: python-splinter-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Python test framework for web applications (common documentation)
 This package contains an open source tool for testing web applications using
 Python. It lets you automate browser actions, such as visiting URLs and
 interacting with their items.
 .
 This is the common documentation package.
