=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%splinter-$1.tar.gz%" \
   https://github.com/cobrateam/splinter/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
