=== debian/changelog ===
splinter (3.0-1+17.1) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Fri, 31 Oct 2025 13:24:17 +0000

splinter (3.0) unstable; urgency=low

  * Initial build version 3.0

 -- Rene van Paassen <Rene.vanPaassen@gmail.com>  Fri, 31 Oct 2025 12:16:52 
 
