=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH := 	      $(shell dpkg-architecture -qDEB_HOST_ARCH)

DEB_CMAKE_EXTRA_FLAGS += -DBUILD_SHARED_LIBS=ON \
		 	 -DCMAKE_INSTALL_LIBDIR:PATH=/usr/lib/$(DEB_HOST_MULTIARCH) \
			 -DLIBRARY_INSTALL_DIRECTORY=lib/$(DEB_HOST_MULTIARCH) \
			 -DEIGEN_DIRECTORY=/usr/include/eigen3 \
			 -DARCH=$(ARCH)
